#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct SavedView {
    #[builder(custom(type = super::SavedViewMetadata, convert = Box::new))]
    #[serde(rename = "metadata")]
    metadata: Box<super::SavedViewMetadata>,
    #[builder(custom(type = super::SearchState, convert = Box::new))]
    #[serde(rename = "searchState")]
    search_state: Box<super::SearchState>,
    #[builder(custom(type = super::DisplayState, convert = Box::new))]
    #[serde(rename = "displayState")]
    display_state: Box<super::DisplayState>,
}
impl SavedView {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        metadata: super::SavedViewMetadata,
        search_state: super::SearchState,
        display_state: super::DisplayState,
    ) -> Self {
        Self::builder()
            .metadata(metadata)
            .search_state(search_state)
            .display_state(display_state)
            .build()
    }
    #[inline]
    pub fn metadata(&self) -> &super::SavedViewMetadata {
        &*self.metadata
    }
    #[inline]
    pub fn search_state(&self) -> &super::SearchState {
        &*self.search_state
    }
    #[inline]
    pub fn display_state(&self) -> &super::DisplayState {
        &*self.display_state
    }
}
